<?php
/**
 * An interface for ProtocolResolvers
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2015 Hub Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
interface ProtocolResolver extends FrameworkInterface {
	/**
	 * Returns an instance of a LocateableNode class for a given NodeHelper
	 * instance or null if it was not found.
	 *
	 * @param	$nodeInstance	An instance of a NodeHelper class
	 * @return	$unlInstance	An instance of a LocateableNode class
	 */
	function resolveUniversalNodeLocatorFromNodeHelper (NodeHelper $nodeInstance);

	/**
	 * Returns the UNL as string from given configuration key.
	 *
	 * @param	$configKey	Configuration key for UNL address (valid: internal,external)
	 * @return	$unl		Universal node locator
	 */
	function resolveUniversalNodeLocatorFromConfigKey ($configKey);
}

// [EOF]
?>
